const fs = require('fs')
const path = require('path')

module.exports = function (dirname, options) {
  options = Object.assign({}, options)
  const modules = {}
  fs.readdirSync(dirname).filter(file => {
    return file.indexOf('.') !== 0 && file !== 'index.js'
  }).forEach(file => {
    const name = file.endsWith('.js') ? file.substr(0, file.lastIndexOf('.')) : file
    const propertyName = options.camelCase ? name.replace(/_([a-z])/g, function (g) { return g[1].toUpperCase() }) : name
    Object.defineProperty(modules, propertyName, {
      configurable: true,
      enumerable: true,
      writeable: true,
      get: function () {
        const _module = options.requireFn ? options.requireFn(dirname, name) : require(path.join(dirname, name))
        Object.defineProperty(modules, propertyName, {
          enumerable: true,
          value: _module
        })
        return _module
      }
    })
  })
  return modules
}
