/* eslint-env node, mocha */
const path = require('path')
const { assert } = require('chai')
const lazyModules = require('../index')

describe('lazy load test modules', function () {
  const modules = lazyModules(path.join(__dirname, 'modules'), { camelCase: true })

  it('modules should be listed properly', function () {
    assert.deepEqual(Object.keys(modules), ['a', 'b', 'c', 'nameWithUnderscores'])
  })
  it('module a should load', function () {
    assert.deepEqual(modules.a, { foo: 'bar' })
  })

  it('module b should load', function () {
    assert.deepEqual(modules.b, { foo: 'bar' })
  })

  it('module c should load', function () {
    assert.deepEqual(modules.c, { foo: 'bar' })
  })

  it('module name_with_underscores should load as camel case', function () {
    assert.deepEqual(modules.nameWithUnderscores, { foo: 'bar' })
  })
})
